<?php
/**
 * The custom template to display the content
 *
 * Used for index/archive/search.
 *
 * @package GRECKO
 * @since GRECKO 1.0.50
 */

$grecko_template_args = get_query_var( 'grecko_template_args' );
if ( is_array( $grecko_template_args ) ) {
	$grecko_columns    = empty( $grecko_template_args['columns'] ) ? 2 : max( 1, $grecko_template_args['columns'] );
	$grecko_blog_style = array( $grecko_template_args['type'], $grecko_columns );
} else {
	$grecko_template_args = array();
	$grecko_blog_style = explode( '_', grecko_get_theme_option( 'blog_style' ) );
	$grecko_columns    = empty( $grecko_blog_style[1] ) ? 2 : max( 1, $grecko_blog_style[1] );
}
$grecko_blog_id       = grecko_get_custom_blog_id( join( '_', $grecko_blog_style ) );
$grecko_blog_style[0] = str_replace( 'blog-custom-', '', $grecko_blog_style[0] );
$grecko_expanded      = ! grecko_sidebar_present() && grecko_get_theme_option( 'expand_content' ) == 'expand';
$grecko_components    = ! empty( $grecko_template_args['meta_parts'] )
							? ( is_array( $grecko_template_args['meta_parts'] )
								? join( ',', $grecko_template_args['meta_parts'] )
								: $grecko_template_args['meta_parts']
								)
							: grecko_array_get_keys_by_value( grecko_get_theme_option( 'meta_parts' ) );
$grecko_post_format   = get_post_format();
$grecko_post_format   = empty( $grecko_post_format ) ? 'standard' : str_replace( 'post-format-', '', $grecko_post_format );

$grecko_blog_meta     = grecko_get_custom_layout_meta( $grecko_blog_id );
$grecko_custom_style  = ! empty( $grecko_blog_meta['scripts_required'] ) ? $grecko_blog_meta['scripts_required'] : 'none';

if ( ! empty( $grecko_template_args['slider'] ) || $grecko_columns > 1 || ! grecko_is_off( $grecko_custom_style ) ) {
	?><div class="
		<?php
		if ( ! empty( $grecko_template_args['slider'] ) ) {
			echo 'slider-slide swiper-slide';
		} else {
			echo esc_attr( ( grecko_is_off( $grecko_custom_style ) ? 'column' : sprintf( '%1$s_item %1$s_item', $grecko_custom_style ) ) . "-1_{$grecko_columns}" );
		}
		?>
	">
	<?php
}
?>
<article id="post-<?php the_ID(); ?>" data-post-id="<?php the_ID(); ?>"
	<?php
	post_class(
			'post_item post_item_container post_format_' . esc_attr( $grecko_post_format )
					. ' post_layout_custom post_layout_custom_' . esc_attr( $grecko_columns )
					. ' post_layout_' . esc_attr( $grecko_blog_style[0] )
					. ' post_layout_' . esc_attr( $grecko_blog_style[0] ) . '_' . esc_attr( $grecko_columns )
					. ( ! grecko_is_off( $grecko_custom_style )
						? ' post_layout_' . esc_attr( $grecko_custom_style )
							. ' post_layout_' . esc_attr( $grecko_custom_style ) . '_' . esc_attr( $grecko_columns )
						: ''
						)
		);
	grecko_add_blog_animation( $grecko_template_args );
	?>
>
	<?php
	// Sticky label
	if ( is_sticky() && ! is_paged() ) {
		?>
		<span class="post_label label_sticky"></span>
		<?php
	}
	// Custom layout
	do_action( 'grecko_action_show_layout', $grecko_blog_id, get_the_ID() );
	?>
</article><?php
if ( ! empty( $grecko_template_args['slider'] ) || $grecko_columns > 1 || ! grecko_is_off( $grecko_custom_style ) ) {
	?></div><?php
	// Need opening PHP-tag above just after </div>, because <div> is a inline-block element (used as column)!
}
