<?php
/**
 * The Portfolio template to display the content
 *
 * Used for index/archive/search.
 *
 * @package GRECKO
 * @since GRECKO 1.0
 */

$grecko_template_args = get_query_var( 'grecko_template_args' );
if ( is_array( $grecko_template_args ) ) {
	$grecko_columns    = empty( $grecko_template_args['columns'] ) ? 2 : max( 1, $grecko_template_args['columns'] );
	$grecko_blog_style = array( $grecko_template_args['type'], $grecko_columns );
    $grecko_columns_class = grecko_get_column_class( 1, $grecko_columns, ! empty( $grecko_template_args['columns_tablet']) ? $grecko_template_args['columns_tablet'] : '', ! empty($grecko_template_args['columns_mobile']) ? $grecko_template_args['columns_mobile'] : '' );
} else {
	$grecko_template_args = array();
	$grecko_blog_style = explode( '_', grecko_get_theme_option( 'blog_style' ) );
	$grecko_columns    = empty( $grecko_blog_style[1] ) ? 2 : max( 1, $grecko_blog_style[1] );
    $grecko_columns_class = grecko_get_column_class( 1, $grecko_columns );
}

$grecko_post_format = get_post_format();
$grecko_post_format = empty( $grecko_post_format ) ? 'standard' : str_replace( 'post-format-', '', $grecko_post_format );

?><div class="
<?php
if ( ! empty( $grecko_template_args['slider'] ) ) {
	echo ' slider-slide swiper-slide';
} else {
	echo ( grecko_is_blog_style_use_masonry( $grecko_blog_style[0] ) ? 'masonry_item masonry_item-1_' . esc_attr( $grecko_columns ) : esc_attr( $grecko_columns_class ));
}
?>
"><article id="post-<?php the_ID(); ?>" 
	<?php
	post_class(
		'post_item post_item_container post_format_' . esc_attr( $grecko_post_format )
		. ' post_layout_portfolio'
		. ' post_layout_portfolio_' . esc_attr( $grecko_columns )
		. ( 'portfolio' != $grecko_blog_style[0] ? ' ' . esc_attr( $grecko_blog_style[0] )  . '_' . esc_attr( $grecko_columns ) : '' )
	);
	grecko_add_blog_animation( $grecko_template_args );
	?>
>
<?php

	// Sticky label
	if ( is_sticky() && ! is_paged() ) {
		?>
		<span class="post_label label_sticky"></span>
		<?php
	}

	$grecko_hover   = ! empty( $grecko_template_args['hover'] ) && ! grecko_is_inherit( $grecko_template_args['hover'] )
								? $grecko_template_args['hover']
								: grecko_get_theme_option( 'image_hover' );

	if ( 'dots' == $grecko_hover ) {
		$grecko_post_link = empty( $grecko_template_args['no_links'] )
								? ( ! empty( $grecko_template_args['link'] )
									? $grecko_template_args['link']
									: get_permalink()
									)
								: '';
		$grecko_target    = ! empty( $grecko_post_link ) && false === strpos( $grecko_post_link, home_url() )
								? ' target="_blank" rel="nofollow"'
								: '';
	}
	
	// Meta parts
	$grecko_components = ! empty( $grecko_template_args['meta_parts'] )
							? ( is_array( $grecko_template_args['meta_parts'] )
								? $grecko_template_args['meta_parts']
								: explode( ',', $grecko_template_args['meta_parts'] )
								)
							: grecko_array_get_keys_by_value( grecko_get_theme_option( 'meta_parts' ) );

	// Featured image
	grecko_show_post_featured( apply_filters( 'grecko_filter_args_featured',
        array(
			'hover'         => $grecko_hover,
			'no_links'      => ! empty( $grecko_template_args['no_links'] ),
			'thumb_size'    => ! empty( $grecko_template_args['thumb_size'] )
								? $grecko_template_args['thumb_size']
								: grecko_get_thumb_size(
									grecko_is_blog_style_use_masonry( $grecko_blog_style[0] )
										? (	strpos( grecko_get_theme_option( 'body_style' ), 'full' ) !== false || $grecko_columns < 3
											? 'masonry-big'
											: 'masonry'
											)
										: (	strpos( grecko_get_theme_option( 'body_style' ), 'full' ) !== false || $grecko_columns < 3
											? 'square'
											: 'square'
											)
								),
			'thumb_bg' => grecko_is_blog_style_use_masonry( $grecko_blog_style[0] ) ? false : true,
			'show_no_image' => true,
			'meta_parts'    => $grecko_components,
			'class'         => 'dots' == $grecko_hover ? 'hover_with_info' : '',
			'post_info'     => 'dots' == $grecko_hover
										? '<div class="post_info"><h5 class="post_title">'
											. ( ! empty( $grecko_post_link )
												? '<a href="' . esc_url( $grecko_post_link ) . '"' . ( ! empty( $target ) ? $target : '' ) . '>'
												: ''
												)
												. esc_html( get_the_title() ) 
											. ( ! empty( $grecko_post_link )
												? '</a>'
												: ''
												)
											. '</h5></div>'
										: '',
            'thumb_ratio'   => 'info' == $grecko_hover ?  '100:102' : '',
        ),
        'content-portfolio',
        $grecko_template_args
    ) );
	?>
</article></div><?php
// Need opening PHP-tag above, because <article> is a inline-block element (used as column)!