<?php
/**
 * The template to display the widgets area in the footer
 *
 * @package GRECKO
 * @since GRECKO 1.0.10
 */

// Footer sidebar
$grecko_footer_name    = grecko_get_theme_option( 'footer_widgets' );
$grecko_footer_present = ! grecko_is_off( $grecko_footer_name ) && is_active_sidebar( $grecko_footer_name );
if ( $grecko_footer_present ) {
	grecko_storage_set( 'current_sidebar', 'footer' );
	$grecko_footer_wide = grecko_get_theme_option( 'footer_wide' );
	ob_start();
	if ( is_active_sidebar( $grecko_footer_name ) ) {
		dynamic_sidebar( $grecko_footer_name );
	}
	$grecko_out = trim( ob_get_contents() );
	ob_end_clean();
	if ( ! empty( $grecko_out ) ) {
		$grecko_out          = preg_replace( "/<\\/aside>[\r\n\s]*<aside/", '</aside><aside', $grecko_out );
		$grecko_need_columns = true;   //or check: strpos($grecko_out, 'columns_wrap')===false;
		if ( $grecko_need_columns ) {
			$grecko_columns = max( 0, (int) grecko_get_theme_option( 'footer_columns' ) );			
			if ( 0 == $grecko_columns ) {
				$grecko_columns = min( 4, max( 1, grecko_tags_count( $grecko_out, 'aside' ) ) );
			}
			if ( $grecko_columns > 1 ) {
				$grecko_out = preg_replace( '/<aside([^>]*)class="widget/', '<aside$1class="column-1_' . esc_attr( $grecko_columns ) . ' widget', $grecko_out );
			} else {
				$grecko_need_columns = false;
			}
		}
		?>
		<div class="footer_widgets_wrap widget_area<?php echo ! empty( $grecko_footer_wide ) ? ' footer_fullwidth' : ''; ?> sc_layouts_row sc_layouts_row_type_normal">
			<?php do_action( 'grecko_action_before_sidebar_wrap', 'footer' ); ?>
			<div class="footer_widgets_inner widget_area_inner">
				<?php
				if ( ! $grecko_footer_wide ) {
					?>
					<div class="content_wrap">
					<?php
				}
				if ( $grecko_need_columns ) {
					?>
					<div class="columns_wrap">
					<?php
				}
				do_action( 'grecko_action_before_sidebar', 'footer' );
				grecko_show_layout( $grecko_out );
				do_action( 'grecko_action_after_sidebar', 'footer' );
				if ( $grecko_need_columns ) {
					?>
					</div><!-- /.columns_wrap -->
					<?php
				}
				if ( ! $grecko_footer_wide ) {
					?>
					</div><!-- /.content_wrap -->
					<?php
				}
				?>
			</div><!-- /.footer_widgets_inner -->
			<?php do_action( 'grecko_action_after_sidebar_wrap', 'footer' ); ?>
		</div><!-- /.footer_widgets_wrap -->
		<?php
	}
}
