<?php
/**
 * The template to display custom header from the ThemeREX Addons Layouts
 *
 * @package GRECKO
 * @since GRECKO 1.0.06
 */

$grecko_header_css   = '';
$grecko_header_image = get_header_image();
$grecko_header_video = grecko_get_header_video();
if ( ! empty( $grecko_header_image ) && grecko_trx_addons_featured_image_override( is_singular() || grecko_storage_isset( 'blog_archive' ) || is_category() ) ) {
	$grecko_header_image = grecko_get_current_mode_image( $grecko_header_image );
}

$grecko_header_id = grecko_get_custom_header_id();
$grecko_header_meta = get_post_meta( $grecko_header_id, 'trx_addons_options', true );
if ( ! empty( $grecko_header_meta['margin'] ) ) {
	grecko_add_inline_css( sprintf( '.page_content_wrap{padding-top:%s}', esc_attr( grecko_prepare_css_value( $grecko_header_meta['margin'] ) ) ) );
}

?><header class="top_panel top_panel_custom top_panel_custom_<?php echo esc_attr( $grecko_header_id ); ?> top_panel_custom_<?php echo esc_attr( sanitize_title( get_the_title( $grecko_header_id ) ) ); ?>
				<?php
				echo ! empty( $grecko_header_image ) || ! empty( $grecko_header_video )
					? ' with_bg_image'
					: ' without_bg_image';
				if ( '' != $grecko_header_video ) {
					echo ' with_bg_video';
				}
				if ( '' != $grecko_header_image ) {
					echo ' ' . esc_attr( grecko_add_inline_css_class( 'background-image: url(' . esc_url( $grecko_header_image ) . ');' ) );
				}
				if ( is_single() && has_post_thumbnail() ) {
					echo ' with_featured_image';
				}
				if ( grecko_is_on( grecko_get_theme_option( 'header_fullheight' ) ) ) {
					echo ' header_fullheight grecko-full-height';
				}
				$grecko_header_scheme = grecko_get_theme_option( 'header_scheme' );
				if ( ! empty( $grecko_header_scheme ) && ! grecko_is_inherit( $grecko_header_scheme  ) ) {
					echo ' scheme_' . esc_attr( $grecko_header_scheme );
				}
				?>
">
	<?php

	// Background video
	if ( ! empty( $grecko_header_video ) ) {
		get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-video' ) );
	}

	// Custom header's layout
	do_action( 'grecko_action_show_layout', $grecko_header_id );

	// Header widgets area
	get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-widgets' ) );

	?>
</header>
