<?php
/**
 * The template to display default site header
 *
 * @package GRECKO
 * @since GRECKO 1.0
 */

$grecko_header_css   = '';
$grecko_header_image = get_header_image();
$grecko_header_video = grecko_get_header_video();
if ( ! empty( $grecko_header_image ) && grecko_trx_addons_featured_image_override( is_singular() || grecko_storage_isset( 'blog_archive' ) || is_category() ) ) {
	$grecko_header_image = grecko_get_current_mode_image( $grecko_header_image );
}

?><header class="top_panel top_panel_default
	<?php
	echo ! empty( $grecko_header_image ) || ! empty( $grecko_header_video ) ? ' with_bg_image' : ' without_bg_image';
	if ( '' != $grecko_header_video ) {
		echo ' with_bg_video';
	}
	if ( '' != $grecko_header_image ) {
		echo ' ' . esc_attr( grecko_add_inline_css_class( 'background-image: url(' . esc_url( $grecko_header_image ) . ');' ) );
	}
	if ( is_single() && has_post_thumbnail() ) {
		echo ' with_featured_image';
	}
	if ( grecko_is_on( grecko_get_theme_option( 'header_fullheight' ) ) ) {
		echo ' header_fullheight grecko-full-height';
	}
	$grecko_header_scheme = grecko_get_theme_option( 'header_scheme' );
	if ( ! empty( $grecko_header_scheme ) && ! grecko_is_inherit( $grecko_header_scheme  ) ) {
		echo ' scheme_' . esc_attr( $grecko_header_scheme );
	}
	?>
">
	<?php

	// Background video
	if ( ! empty( $grecko_header_video ) ) {
		get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-video' ) );
	}

	// Main menu
	get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-navi' ) );

	// Mobile header
	if ( grecko_is_on( grecko_get_theme_option( 'header_mobile_enabled' ) ) ) {
		get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-mobile' ) );
	}

	// Page title and breadcrumbs area
	if ( ! is_single() ) {
		get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-title' ) );
	}

	// Header widgets area
	get_template_part( apply_filters( 'grecko_filter_get_template_part', 'templates/header-widgets' ) );
	?>
</header>
