<?php
/**
 * The template to display the logo or the site name and the slogan in the Header
 *
 * @package GRECKO
 * @since GRECKO 1.0
 */

$grecko_args = get_query_var( 'grecko_logo_args' );

// Site logo
$grecko_logo_type   = isset( $grecko_args['type'] ) ? $grecko_args['type'] : '';
$grecko_logo_image  = grecko_get_logo_image( $grecko_logo_type );
$grecko_logo_text   = grecko_is_on( grecko_get_theme_option( 'logo_text' ) ) ? get_bloginfo( 'name' ) : '';
$grecko_logo_slogan = get_bloginfo( 'description', 'display' );
if ( ! empty( $grecko_logo_image['logo'] ) || ! empty( $grecko_logo_text ) ) {
	?><a class="sc_layouts_logo" href="<?php echo esc_url( home_url( '/' ) ); ?>">
		<?php
		if ( ! empty( $grecko_logo_image['logo'] ) ) {
            if ( empty( $grecko_logo_type ) && function_exists( 'the_custom_logo' ) && is_numeric($grecko_logo_image['logo']) && (int) $grecko_logo_image['logo'] > 0 ) {
				the_custom_logo();
			} else {
				$grecko_attr = grecko_getimagesize( $grecko_logo_image['logo'] );
				echo '<img src="' . esc_url( $grecko_logo_image['logo'] ) . '"'
						. ( ! empty( $grecko_logo_image['logo_retina'] ) ? ' srcset="' . esc_url( $grecko_logo_image['logo_retina'] ) . ' 2x"' : '' )
						. ' alt="' . esc_attr( $grecko_logo_text ) . '"'
						. ( ! empty( $grecko_attr[3] ) ? ' ' . wp_kses_data( $grecko_attr[3] ) : '' )
						. '>';
			}
		} else {
			grecko_show_layout( grecko_prepare_macros( $grecko_logo_text ), '<span class="logo_text">', '</span>' );
			grecko_show_layout( grecko_prepare_macros( $grecko_logo_slogan ), '<span class="logo_slogan">', '</span>' );
		}
		?>
	</a>
	<?php
}
