<?php
/**
 * The template to display the widgets area in the header
 *
 * @package GRECKO
 * @since GRECKO 1.0
 */

// Header sidebar
$grecko_header_name    = grecko_get_theme_option( 'header_widgets' );
$grecko_header_present = ! grecko_is_off( $grecko_header_name ) && is_active_sidebar( $grecko_header_name );
if ( $grecko_header_present ) {
	grecko_storage_set( 'current_sidebar', 'header' );
	$grecko_header_wide = grecko_get_theme_option( 'header_wide' );
	ob_start();
	if ( is_active_sidebar( $grecko_header_name ) ) {
		dynamic_sidebar( $grecko_header_name );
	}
	$grecko_widgets_output = ob_get_contents();
	ob_end_clean();
	if ( ! empty( $grecko_widgets_output ) ) {
		$grecko_widgets_output = preg_replace( "/<\/aside>[\r\n\s]*<aside/", '</aside><aside', $grecko_widgets_output );
		$grecko_need_columns   = strpos( $grecko_widgets_output, 'columns_wrap' ) === false;
		if ( $grecko_need_columns ) {
			$grecko_columns = max( 0, (int) grecko_get_theme_option( 'header_columns' ) );
			if ( 0 == $grecko_columns ) {
				$grecko_columns = min( 6, max( 1, grecko_tags_count( $grecko_widgets_output, 'aside' ) ) );
			}
			if ( $grecko_columns > 1 ) {
				$grecko_widgets_output = preg_replace( '/<aside([^>]*)class="widget/', '<aside$1class="column-1_' . esc_attr( $grecko_columns ) . ' widget', $grecko_widgets_output );
			} else {
				$grecko_need_columns = false;
			}
		}
		?>
		<div class="header_widgets_wrap widget_area<?php echo ! empty( $grecko_header_wide ) ? ' header_fullwidth' : ' header_boxed'; ?>">
			<?php do_action( 'grecko_action_before_sidebar_wrap', 'header' ); ?>
			<div class="header_widgets_inner widget_area_inner">
				<?php
				if ( ! $grecko_header_wide ) {
					?>
					<div class="content_wrap">
					<?php
				}
				if ( $grecko_need_columns ) {
					?>
					<div class="columns_wrap">
					<?php
				}
				do_action( 'grecko_action_before_sidebar', 'header' );
				grecko_show_layout( $grecko_widgets_output );
				do_action( 'grecko_action_after_sidebar', 'header' );
				if ( $grecko_need_columns ) {
					?>
					</div>	<!-- /.columns_wrap -->
					<?php
				}
				if ( ! $grecko_header_wide ) {
					?>
					</div>	<!-- /.content_wrap -->
					<?php
				}
				?>
			</div>	<!-- /.header_widgets_inner -->
			<?php do_action( 'grecko_action_after_sidebar_wrap', 'header' ); ?>
		</div>	<!-- /.header_widgets_wrap -->
		<?php
	}
}
