<?php
/**
 * The template to display Admin notices
 *
 * @package GRECKO
 * @since GRECKO 1.0.64
 */

$grecko_skins_url  = get_admin_url( null, 'admin.php?page=trx_addons_theme_panel#trx_addons_theme_panel_section_skins' );
$grecko_skins_args = get_query_var( 'grecko_skins_notice_args' );
?>
<div class="grecko_admin_notice grecko_skins_notice notice notice-info is-dismissible" data-notice="skins">
	<?php
	// Theme image
	$grecko_theme_img = grecko_get_file_url( 'screenshot.jpg' );
	if ( '' != $grecko_theme_img ) {
		?>
		<div class="grecko_notice_image"><img src="<?php echo esc_url( $grecko_theme_img ); ?>" alt="<?php esc_attr_e( 'Theme screenshot', 'grecko' ); ?>"></div>
		<?php
	}

	// Title
	?>
	<h3 class="grecko_notice_title">
		<?php esc_html_e( 'New skins available', 'grecko' ); ?>
	</h3>
	<?php

	// Description
	$grecko_total      = $grecko_skins_args['update'];	// Store value to the separate variable to avoid warnings from ThemeCheck plugin!
	$grecko_skins_msg  = $grecko_total > 0
							// Translators: Add new skins number
							? '<strong>' . sprintf( _n( '%d new version', '%d new versions', $grecko_total, 'grecko' ), $grecko_total ) . '</strong>'
							: '';
	$grecko_total      = $grecko_skins_args['free'];
	$grecko_skins_msg .= $grecko_total > 0
							? ( ! empty( $grecko_skins_msg ) ? ' ' . esc_html__( 'and', 'grecko' ) . ' ' : '' )
								// Translators: Add new skins number
								. '<strong>' . sprintf( _n( '%d free skin', '%d free skins', $grecko_total, 'grecko' ), $grecko_total ) . '</strong>'
							: '';
	$grecko_total      = $grecko_skins_args['pay'];
	$grecko_skins_msg .= $grecko_skins_args['pay'] > 0
							? ( ! empty( $grecko_skins_msg ) ? ' ' . esc_html__( 'and', 'grecko' ) . ' ' : '' )
								// Translators: Add new skins number
								. '<strong>' . sprintf( _n( '%d paid skin', '%d paid skins', $grecko_total, 'grecko' ), $grecko_total ) . '</strong>'
							: '';
	?>
	<div class="grecko_notice_text">
		<p>
			<?php
			// Translators: Add new skins info
			echo wp_kses_data( sprintf( __( "We are pleased to announce that %s are available for your theme", 'grecko' ), $grecko_skins_msg ) );
			?>
		</p>
	</div>
	<?php

	// Buttons
	?>
	<div class="grecko_notice_buttons">
		<?php
		// Link to the theme dashboard page
		?>
		<a href="<?php echo esc_url( $grecko_skins_url ); ?>" class="button button-primary"><i class="dashicons dashicons-update"></i> 
			<?php
			// Translators: Add theme name
			esc_html_e( 'Go to Skins manager', 'grecko' );
			?>
		</a>
	</div>
</div>
